#ifndef INCLUDED_GLOBAL
#define INCLUDED_GLOBAL

#define MAX_ARGS 		10
#define MAX_DANCERS		10
#define MAX_VIEWTRACK	10

#define NB_DOF			49
#define NB_JOINTS		24

#define OBJ_PART		100
#define OBJ_NB_PART		19

#define SELECT_BUFSIZE	512


//================================================================================================
//
//		Definitions
//
//================================================================================================

enum { OBJ_AXIS = 1, 
	   OBJ_SPHERE, OBJ_SPHERE_XZ, OBJ_SPHERE_X_ONLY, OBJ_SPHERE_Z_ONLY, OBJ_DISK,

	   // name of the parts
	   OBJ_TORSO = OBJ_PART, OBJ_PELVIS, OBJ_NECK, OBJ_HEADFACE, OBJ_HEADHAIR,
 
	   OBJ_LEFT_THIGH, OBJ_LEFT_LEG, OBJ_LEFT_FOOT, OBJ_LEFT_TOE,
	   OBJ_LEFT_ARM, OBJ_LEFT_FOREARM, OBJ_LEFT_HAND, 

	   OBJ_RIGHT_THIGH, OBJ_RIGHT_LEG, OBJ_RIGHT_FOOT, OBJ_RIGHT_TOE,
	   OBJ_RIGHT_ARM, OBJ_RIGHT_FOREARM, OBJ_RIGHT_HAND, 

	   // specific parts of Man & Woman
	   OBJ_TORSO_MAN, OBJ_TORSO_WOMAN,
     };

enum {MAN, WOMAN};

enum {BODY, GHOST, FOOT};


#ifndef WIN32
enum {FALSE=0, TRUE=-1};
#endif

enum {SHADED, WIRE, FORCE_WIRE, SELECT, GETPOS};
enum {PERSP, ORTHO};

enum {COMPILE, PARSE};						// mode for routine parse
enum {NORMAL, FORCE, QUERY, APPLYMODIF};	// mode for track update

//================================================================================================
//
//		Globals + Prototypes
//
//================================================================================================

extern char error[];


extern int BodyCreate_Cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
extern int LightCreate_Cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
extern int RoutineCreate_Cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
extern int View3D_ObjCmd(ClientData clientData, Tcl_Interp *interp, int objc, 
						 Tcl_Obj *CONST objv[]);
extern int ViewMovie_ObjCmd(ClientData clientData, Tcl_Interp *interp, int objc, 
						 Tcl_Obj *CONST objv[]);
extern int ViewTrack_ObjCmd(ClientData clientData, Tcl_Interp *interp, int objc, 
							Tcl_Obj *CONST objv[]);

extern int Check_ObjCmd(ClientData clientData, Tcl_Interp *interp, int objc,
							Tcl_Obj *CONST objv[]);


extern void ObjectsInit();

extern "C" {
extern int Togl_DefaultProcessing(struct Togl *togl, Tcl_Interp *interp,
				int index, int objc, Tcl_Obj *CONST objv[]);
}


#endif
