namespace eval stage {
	variable list {}

	image create pixmap plusX -file pixmap/right.xpm
	image create pixmap moinsX -file pixmap/left.xpm
	image create pixmap plusY -file pixmap/plusy.xpm
	image create pixmap moinsY -file pixmap/moinsy.xpm
	image create pixmap plusZ -file pixmap/forward.xpm
	image create pixmap moinsZ -file pixmap/back.xpm

	image create pixmap plusRX -file pixmap/plusrx.xpm
	image create pixmap moinsRX -file pixmap/moinsrx.xpm
	image create pixmap plusRY -file pixmap/plusry.xpm
	image create pixmap moinsRY -file pixmap/moinsry.xpm
	image create pixmap plusRZ -file pixmap/plusrz.xpm
	image create pixmap moinsRZ -file pixmap/moinsrz.xpm

	image create pixmap tbs_ghost -file pixmap/tb_stg_ghost.xpm
	image create pixmap tbs_foot -file pixmap/tb_stg_foot.xpm
	image create pixmap tbs_tobody -file pixmap/tb_stg_tobody.xpm
	image create pixmap tbs_reset -file pixmap/tb_stg_reset.xpm

	image create pixmap tbs_store -file pixmap/tb_stg_store.xpm
	image create pixmap tbs_restore -file pixmap/tb_stg_restore.xpm
}

#-------------------------------------------------------------------------------------------------

proc stage::new {w routineEditor {pos ""} {size ""}} {
global status
variable list
variable $w
upvar 0 $w data

    toplevel $w
	if {$pos != "" || $size != ""} {
	    wm geometry $w $size$pos
	}
	wm title $w "Stage <[[routine::getRoutine $routineEditor] get name]>"
	wm protocol $w WM_DELETE_WINDOW "main::closeWindow $w"
	bind $w <Escape> "after idle \"main::closeWindow $w\""

	# register the editor
	lappend list $w

	# the status bar
	set s [frame $w.s]
	label $s.help -relief sunken -bd 1 -font status \
			-textvariable stage::${w}(st:help)
	pack $s.help -side left -expand yes -fill x
	pack $s -side bottom -fill x -pady 1 -padx 1

	# the left frame
	set left [frame $w.left]
	  # the view
	  set data(w:view) [togl $left.t -width 200 -height 300 -ident "$w" \
				  -double true -depth true -class view3D -share $status(opengl)]
	  initView $w
	  pack $data(w:view) -side top -expand yes -fill both
	  bindtags $data(w:view) "[bindtags $data(w:view)] KeyGhost KeyRoutine"
	  # the comment
	  pack [frame $left.sep -width 10 -height 2] -side top -fill x
	  set data(w:comment) [label $left.c -bd 1 -relief sunken -font status -justify left \
							-anchor nw -height 1 -width 1]
	  pack $data(w:comment) -side top -fill x
	pack $left -side left -expand yes -fill both -padx 3 -pady 3

	# top right : management of CoG
	set f [frame $w.cog]
	  # the current body
      set data(w:bodies) [tixCheckList $f.bodies -scrollbar auto -highlightthickness 0 \
			-options {	hlist.columns		3 } ]
		set hlist [$data(w:bodies) subwidget hlist]
		$hlist configure -font stage -width 12 -height 4 -indicator 0 -indent 0 -pady 2 \
				-bd 1 -wideselection true
		#$hlist configure -font stage -height 6 -indicator 0 -indent 0 \
		#		-columns 3 -padY 2 -wideselection true -width 12 -bd 2
		bind $hlist <1> "stage::body:toggle $w %x %y"
		bindtags $hlist [list $hlist $w all]	;# remove all bindings with TixHList

	  # the orientation
	  set orient [frame $f.orientation -bd 2 -relief groove]
	  set ff $orient
		set a [frame $ff.a]
		  set data(w:orient) [canvas $a.orient -width 50 -height 50 \
				-highlightthickness 0 -bg white]
			_button $a.ry1 $w plusRY cog:rY {-45 -10 -1}
			_button $a.ry2 $w moinsRY cog:rY {45 10 1}
			orient:init $a.orient $w
		  pack $a.ry1 $a.orient $a.ry2 -side left -padx 2
		set b [frame $ff.b]
		set l [frame $ff.l]
	  	# X		
		_button $b.x1 $w plusRX cog:rX {10 1 .1}
		_button $b.x2 $w moinsRX cog:rX {-10 -1 -.1}
		_entry $l.lx $w "Rot X" cog:rX
		# Y
		_entry $l.ly $w "Rot Y" cog:rY
		# Z
		_button $b.z1 $w plusRZ cog:rZ {10 1 .1}
		_button $b.z2 $w moinsRZ cog:rZ {-10 -1 -.1}
		_entry $l.lz $w "Rot Z" cog:rZ
		grid $b.z1		$b.x1	-padx 5 -pady 2
		grid $b.z2		$b.x2	-padx 5 -pady 2

		grid $l.lx		$l.lx2	-padx 2
		grid $l.ly		$l.ly2	-padx 2
		grid $l.lz		$l.lz2	-padx 2

		# layout
		grid $a
		grid $b	-pady 5
		grid $l
		pack $ff

	  # the position
	  set pos [frame $f.pos -bd 2 -relief groove]
	  set ff $pos
		# X
		_button $ff.x1 $w plusX cog:X {10 1 .1}
		_button $ff.x2 $w moinsX cog:X {-10 -1 -.1}
		_entry $ff.lx $w "Cog X" cog:X
		# Y
		_button $ff.y1 $w plusY cog:Y {10 1 .1}
		_button $ff.y2 $w moinsY cog:Y {-10 -1 -.1}
		_entry $ff.ly $w "Cog Y" cog:Y
		# Z
		_button $ff.z1 $w plusZ cog:Z {10 1 .1}
		_button $ff.z2 $w moinsZ cog:Z {-10 -1 -.1}
		_entry $ff.lz $w "Cog Z" cog:Z

		label $ff.sep

		grid x		$ff.z2	x		x	$ff.y1	-sticky news
		grid $ff.x2	x		$ff.x1	x	$ff.y2	-sticky news
		grid x		$ff.z1	x		x	x		-sticky news
		grid $ff.sep -		-		-	-		-sticky news
		grid $ff.lx	-		$ff.lx2	-	-		-sticky news
		grid $ff.ly	-		$ff.ly2	-	-		-sticky news
		grid $ff.lz	-		$ff.lz2	-	-		-sticky news
		

	grid $f.bodies	-		-sticky news -padx 3 -pady 3
	grid $orient	$pos	-sticky new -padx 3 -pady 3 -ipadx 3 -ipady 3

	pack $f -anchor w -side top


	# toolbar with display options & some commands
	pack [frame $w.sep] -padx 2 -pady 5 -side top

	set tb [toolbar::new $w.tb -bd 1]
	  toolbar::add:check $tb ghost -bd 1 -image tbs_ghost -variable stage::${w}(v:ghost) \
			-oncommand "stage::ghost:toggle $w add" -offcommand "stage::ghost:toggle $w remove" \
			-tip "Show/Hide the ghosts bodies"
	  bind $w <g> "stage::ghost:toggle:key $w"
	  toolbar::add:check $tb foot -bd 1 -image tbs_foot -variable stage::${w}(v:foot) \
			-oncommand "stage::foot:toggle $w foot" -offcommand "stage::foot:toggle $w ghost" \
			-tip "Show only feet or whole body"
	  bind $w <f> "stage::foot:toggle:key $w"
	  toolbar::add:separator $tb 25
	  toolbar::add:button $tb tobody -bd 1 -image tbs_tobody \
			-command "stage::view:reset $w tobody" \
			-tip "Center view to bodies"
	  toolbar::add:button $tb reset3D -bd 1 -image tbs_reset \
			-command "stage::view:reset $w view" \
			-tip "Reset the 3D view to standard values"
	pack $tb -padx 2 -pady 0 -anchor sw -side top

	set data(w:ghostdelay) [tixControl $w.ghostdelay -label "Time " -step 50 \
			-integer true -variable stage::${w}(v:ghost:time) -min 0 \
			-command "stage::ghost:sync $w" \
			-options { label.font routine:time entry.font routine:time entry.justify right \
					   entry.borderWidth 1 entry.width 5 entry.highlightColor lightgray}]
	pack $w.ghostdelay -padx 2 -pady 0 -anchor w -side top


	# sync
	button $w.sync -text "Sync" -command "stage::sync $w"
	pack $w.sync -padx 2 -pady 5 -anchor w -side top

	# memo
	global memo
	set m [frame $w.memo]
	  foreach i {0 1 2} {
		frame $m.$i
		set data(w:memo:$i) [label $m.$i.l -image $memo($i:image) -bd 1 -relief sunken]
		button $m.$i.s -image tbs_store -bd 1 -command "stage::memo:store $w $i"
		button $m.$i.r -image tbs_restore -bd 1 -command "stage::memo:restore $w $i"
		grid $m.$i.l -
		grid $m.$i.s $m.$i.r -pady 1
	  }
	  pack $m.0 $m.1 $m.2 -padx 2 -side left

	pack $m -fill x -expand true -anchor nw -side top

	# the drag & drop facility
	drag&drop::target add $data(w:view) -type "pose position" -checkcmd "stage::drop:check $w" \
			-cmd "stage::drop:cmd $w" -cleanupcmd "stage::drop:cleanup $w"
	  # menu to choose relative if more than 2 bodies
	  set data(m:relative) [menu $w.relative -activeborderwidth 1 -bd 1 \
			  -font menubutton -tearoff 0]

	# some settings
	set data(v:routineEditor) $routineEditor
	set data(v:bodies) {}
	set data(v:bodies:ghost) {}
	set stage::${w}(v:ghost) 1		;# because of toolbar
	set stage::${w}(v:foot) 1		;# because of toolbar
	set stage::${w}(v:ghost:time) 0	;# because of tixControl
}

proc stage::close {w} {
variable list
variable $w
upvar 0 $w data

	set i [lsearch -exact $list $w]
	set list [lreplace $list $i $i]
	# remove array associated with window
	catch {unset data}
}

proc stage::_button {w wdata name var incr} {
	button $w -image $name -bd 1 -padx 0 -pady 0
	foreach b {<Button-1> <Shift-Button-1> <Control-Button-1>} i $incr {
		bind $w $b "stage::pos:adjust $wdata $var $i"
	}
	bind $w <Any-ButtonRelease-1> "after cancel \[set stage::${wdata}(v:pending)\]"
}

proc stage::_entry {w wdata text var} {
global status

	label $w -font entry:small -text $text
	entry ${w}2 -font entry:small -textvariable stage::${wdata}(v:$var) \
			-relief sunken -bd 1 -justify right -width 7
	bind ${w}2 <FocusOut> "stage::validateEntry $wdata $var"
	bind ${w}2 <Return> "stage::validateEntry $wdata $var"
}

#=================================================================================================

proc stage::drop:check {wdata w x y sent} {
variable $wdata
upvar 0 $wdata data

	catch { $data(t:body) unselect all }

	set what [$w pickjoint $x $y]
	if {$what != ""} {
		[lindex $what 0] select all
		set data(t:body) [lindex $what 0]
		return target
	}

	return ""
}

proc stage::drop:cleanup {wdata} {
variable $wdata
upvar 0 $wdata data

	catch { $data(t:body) unselect all }
}

proc stage::drop:cmd {wdata w type sent} {
variable $wdata
upvar 0 $wdata data

	$data(t:body) unselect all

	if {$type == "pose"} {
		foreach entry $sent {
			$data(t:body) set [lindex $entry 0] [lindex $entry 1]
		}
		if {![info exists data(v:bodies:poseDropped)] ||
				[lsearch -exact $data(v:bodies:poseDropped) $data(t:body)] == -1} {
			lappend data(v:bodies:poseDropped) $data(t:body)
		}
	} else {
		$data(m:relative) delete 0 end
		$data(m:relative) add command -label "Choose relative body"
		$data(m:relative) add separator
		foreach b $data(v:bodies) {
			if {$b != $data(t:body)} {
				$data(m:relative) add command -label [$b get name] -command \
						"stage::drop:setPosition [winfo toplevel $w] $data(t:body) $b {$sent}"
				if {![info exists ref]} { set ref $b }
			}
		}
		if {[llength $data(v:bodies)] == 2} {
			stage::drop:setPosition [winfo toplevel $w] $data(t:body) $ref $sent
		} else {
			tk_popup $data(m:relative) [winfo pointerx $w] [winfo pointery $w]
		}
	}

	unset data(t:body)
}

proc stage::drop:setPosition {w body refBody position} {
variable $w
upvar 0 $w data


	foreach entry $position {
		set [lindex $entry 0] [lindex $entry 1]
	}

	# set altitude, roll, bend
	catch { $body set cog:Y [set cog:Y] }
	catch { $body set cog:rX [set cog:rX] }
	catch { $body set cog:rZ [set cog:rZ] }

	# set position on floor (use rotation + coordinate X/Z)
	if {[info exist cog:rY]} {
		$body set cog:rY [expr [$refBody get cog:rY]+[set cog:rY]]

		set cos [expr cos([$refBody get cog:rY]*3.141592654/180)]
		set sin [expr sin([$refBody get cog:rY]*3.141592654/180)]
		$body set cog:X [expr $cos*[set cog:X]-$sin*[set cog:Z] + [$refBody get cog:X]]
		$body set cog:Z [expr $sin*[set cog:X]+$cos*[set cog:Z] + [$refBody get cog:Z]]
	} else {
		$body set cog:X [expr [$refBody get cog:X]+[set cog:X]]
		$body set cog:Z [expr [$refBody get cog:Z]+[set cog:Z]]
	}

	# select dropped body & update display
	body:select $w $body
}

#=================================================================================================

proc stage::add {w bodies} {
variable $w
upvar 0 $w data

	set hlist [$data(w:bodies) subwidget hlist]

	foreach b $bodies {
		lappend data(v:bodies) $b
		set data(v:bodies:shown:$b) 1
		$data(w:view) add $b
		# add body in the list for selection
		set entry [$hlist addchild {} -data $b]
		$hlist item create $entry 1 -itemtype text -text [$b get name]
		$data(w:bodies) setstatus $entry on
		# selection of body
		bind $data(w:view) <Key-[expr $entry+1]> "stage::body:adjust $w $entry"
		# new body the shadow in wireframe
		set newb [body [$b get name]]
		eval $newb setcolor [$b getcolor all]
		$newb set sex [$b get sex]
		if {$data(v:foot)} {
			$newb set ghost foot
		} else {
			$newb set ghost ghost
		}
		if {$data(v:ghost)} {
			$data(w:view) add $newb
		}
		$newb wire all
		lappend data(v:bodies:ghost) $newb
	}

	body:adjust $w 0
}

proc stage::body:toggle {w x y} {
variable $w
upvar 0 $w data

	set hlist [$data(w:bodies) subwidget hlist]

    # search the new item used for ordering
	set xmin 0
	foreach col {0 1 2} {
		if {$x <= $xmin+[$hlist column width $col]} {
			break;
		}
		incr xmin [$hlist column width $col]
	}
	if {$col==3} {
		return
	}

	set entry [$hlist nearest $y]

	if {$col == 0} {
		# toggle
		set body [$hlist info data $entry]
		if {[$data(w:bodies) getstatus $entry] == "on"} {
			$data(w:bodies) setstatus $entry off
			$data(w:view) remove $body
			set data(v:bodies:shown:$body) 0
			if {$data(v:ghost)} {
				$data(w:view) remove [lindex $data(v:bodies:ghost) \
											[lsearch -exact $data(v:bodies) $body]]
			}
		} else {
			$data(w:bodies) setstatus $entry on
			if {$data(v:ghost)} {
				$data(w:view) add [lindex $data(v:bodies:ghost) \
										[lsearch -exact $data(v:bodies) $body]]
			}
			$data(w:view) add $body
			set data(v:bodies:shown:$body) 1
		}

	} else {
		# select body
		body:adjust $w $entry
	}
}

proc stage::body:select {w body} {
variable $w
upvar 0 $w data

	set hlist [$data(w:bodies) subwidget hlist]
	foreach entry [$hlist info children] {
		if {[$hlist info data $entry] == $body} {
			body:adjust $w $entry
			return
		}
	}
}

#-------------------------------------------------------------------------------------------------

proc stage::ghost:toggle:key {w} {
variable $w
upvar 0 $w data

	if {$data(v:ghost)} {
		ghost:toggle $w remove
		set stage::${w}(v:ghost) 0
	} else {
		ghost:toggle $w add
		set stage::${w}(v:ghost) 1
	}
}

proc stage::ghost:toggle {w mode} {
variable $w
upvar 0 $w data

	# handle bodies
	set hlist [$data(w:bodies) subwidget hlist]
	foreach entry [$hlist info children] {
		set body [$hlist info data $entry]
		if {[$data(w:bodies) getstatus $entry] == "on"} {
			$data(w:view) $mode [lindex $data(v:bodies:ghost) \
									[lsearch -exact $data(v:bodies) $body]]
		}
	}
	# enable/disable the control for delay
	if {$mode == "add"} {
		$data(w:ghostdelay) configure -state normal
	} else {
		$data(w:ghostdelay) configure -state disabled
	}
	# resync the ghosts
	ghost:sync $w
}

proc stage::foot:toggle:key {w} {
variable $w
upvar 0 $w data

	if {$data(v:foot)} {
		foot:toggle $w ghost
		set stage::${w}(v:foot) 0
	} else {
		foot:toggle $w foot
		set stage::${w}(v:foot) 1
	}
}

proc stage::foot:toggle {w mode} {
variable $w
upvar 0 $w data

	foreach b $data(v:bodies:ghost) {
		$b set ghost $mode
	}
}

proc stage::ghost:sync {w {time -1}} {
variable $w
upvar 0 $w data

	# resync the ghost with the routine
	set routine [routine::getRoutine $data(v:routineEditor)]
	if {$time >= 0} {
		set max [$routine get beats]
		if {$time > $max} {
			set time $max
		}
		set stage::${w}(v:ghost:time) $time
	}
	set i 0
	foreach b $data(v:bodies:ghost) {
		$routine applyto $i $data(v:ghost:time) $b
		incr i
	}
}

proc stage::ghost:get {w dancer} {
variable $w
upvar 0 $w data

	return [lindex $data(v:bodies:ghost) $dancer]
}

# bindings for the time of the ghost
if {$tcl_platform(platform) == "windows"} {
	bind KeyGhost <Mod2-Left> "stage::ghost:adjustTime %W -5; break"
	bind KeyGhost <Mod2-Right> "stage::ghost:adjustTime %W +5; break"
	bind KeyGhost <Shift-Mod2-Left> "stage::ghost:adjustTime %W -1; break"
	bind KeyGhost <Shift-Mod2-Right> "stage::ghost:adjustTime %W +1; break"
	bind KeyGhost <Mod2-Up> "stage::ghost:adjustTime %W end; break"
	bind KeyGhost <Mod2-Down> "stage::ghost:adjustTime %W zero; break"
} else {
	bind KeyGhost <Mod1-Left> "stage::ghost:adjustTime %W -5; break"
	bind KeyGhost <Mod1-Right> "stage::ghost:adjustTime %W +5; break"
	bind KeyGhost <Shift-Mod1-Left> "stage::ghost:adjustTime %W -1; break"
	bind KeyGhost <Shift-Mod1-Right> "stage::ghost:adjustTime %W +1; break"
	bind KeyGhost <Mod1-Up> "stage::ghost:adjustTime %W end; break"
	bind KeyGhost <Mod1-Down> "stage::ghost:adjustTime %W zero; break"
}

proc stage::ghost:adjustTime {w deltaT} {
variable [winfo toplevel $w]
upvar 0 [winfo toplevel $w] data

	# adjust according to increment
	set max [[routine::getRoutine $data(v:routineEditor)] get beats]
	if {$deltaT == "zero"} {
		set time 0
	} elseif {$deltaT == "end"} {
		set time $max
	} else {
		set time [expr ($data(v:ghost:time)/50/$deltaT)*$deltaT*50]
		set time [expr $time + $deltaT*50]
		if {$time < 0} {
			set time 0
		}
	}

	ghost:sync [winfo toplevel $w] $time
}

#-------------------------------------------------------------------------------------------------

proc stage::sync {w} {
variable $w
upvar 0 $w data

	# update the routine if user press 'sync'
	foreach b $data(v:bodies) {
		routine::update $data(v:routineEditor) cog $b
	}
	# update the joints : do nothing by defaults, else record changes
#	if {[info exists data(v:bodies:poseDropped)]} {
#		foreach b $data(v:bodies:poseDropped) {
		foreach b $data(v:bodies) {
			routine::update $data(v:routineEditor) joints $b
		}
#		}
#		unset data(v:bodies:poseDropped)
#	}
	# sync the ghost
	if {$data(v:ghost)} {
		ghost:sync $w
	}
}

#-------------------------------------------------------------------------------------------------

proc stage::sync:names {w} {
variable $w
upvar 0 $w data


	set hlist [$data(w:bodies) subwidget hlist]
	foreach entry [$hlist info children] {
		set body [$hlist info data $entry]
		$hlist item configure $entry 1 -text [$body get name]
	}
}

#=================================================================================================

proc stage::prefFloor {w nbX nbZ} {
variable $w
upvar 0 $w data

	$data(w:view) set floor:nbX $nbX
	$data(w:view) set floor:nbZ $nbZ
}

#=================================================================================================


proc stage::view {w mode} {
variable $w
upvar 0 $w data
variable help

	set old $data(mode:old)
	set data(mode:old) $mode

	set data(var:$old) [$data(w:view) get view]

	if {$mode == "3d"} {
		$data(w:view) persp
	} else {
		$data(w:view) ortho
	}
	$data(w:view) set view $data(var:$mode)

	if {$mode == "3d"} {
		replaceBindtags $data(w:view) "View3DProjection" "View3D"
		set help(normal) $help(3d:normal)
		set help(alt) $help(3d:alt)
	} else {
		replaceBindtags $data(w:view) "View3D" "View3DProjection"
		set help(normal) $help(proj:normal)
		set help(alt) $help(proj:alt)
	}

}

#-------------------------------------------------------------------------------------------------

proc stage::view:reset {w action} {
variable $w
upvar 0 $w data

	switch -exact $action {
		view			{ $data(w:view) set view $data(std:$data(mode)) }

		tobody			{ $data(w:view) set xtrans [lindex $data(std:$data(mode)) 4]
						  $data(w:view) set ytrans [lindex $data(std:$data(mode)) 5] 
						  set xpos 0
						  set zpos 0
						  foreach b $data(v:bodies) {
							  set xpos [expr $xpos + [$b get cog:X]]
							  set zpos [expr $zpos + [$b get cog:Z]]
						  }
						  $data(w:view) set xpos [expr $xpos/100/[llength $data(v:bodies)]]
						  $data(w:view) set zpos [expr $zpos/100/[llength $data(v:bodies)]]
						  $data(w:view) set ypos 0
						}
	}
}


#=================================================================================================


proc stage::memo:store {w i} {
variable $w
upvar 0 $w data
global status
global memo


	set memo($i:data) {}
	# find first shown body
	foreach b $data(v:bodies) {
		if {$data(v:bodies:shown:$b) == 0} {
			continue
		}
		set first $b
		break
	}

	foreach b $data(v:bodies) {
		# check if shown or hidden
		if {$data(v:bodies:shown:$b) == 0} {
			continue
		}
		# get pose
		set pose [$b get pose]
		# get relative position
		if {$b == $first} {
			set cog {0 0 0 0 0 0}
		} else {
			set cog {}
			foreach val [$b get cog] ref [$first get cog] {
				lappend cog [expr $val-$ref]
			}
		}
		# store it
		lappend memo($i:data) $pose $cog
	}

	# set the icon with snapshot & save file
	set filename $status(dir:library)/memo.private.$i
	set out [open $filename "w"]
	fconfigure $out -translation binary
	puts $out "#$memo($i:data)"
	puts -nonewline $out [$data(w:view) snapshot $memo(width) $memo(height)]
	flush $out
	close $out
	# delete old image
	image delete $memo($i:image)
	# set new one
	set memo($i:image) [image create photo -file $filename]
	$data(w:memo:$i) configure -image $memo($i:image)
}

#-------------------------------------------------------------------------------------------------

proc stage::memo:restore {w i} {
variable $w
upvar 0 $w data
global memo


	if {$memo($i:data) == {}} {
		return
	}

	# construct list of visible bodies & find first
	set bodies {}
	foreach b $data(v:bodies) {
		if {$data(v:bodies:shown:$b) == 0} {
			continue
		}
		lappend bodies $b
	}
	set first [lindex $bodies 0]

	foreach b $bodies {pose cog} $memo($i:data) {
		# check if shown or hidden
		if {$data(v:bodies:shown:$b) == 0 || $pose == {}} {
			continue
		}
		# set pose
		$b set pose $pose
		# set relative position
		if {$b != $first} {
			set newcog {}
			foreach val $cog ref [$first get cog] {
				lappend newcog [expr $ref+$val]
			}
			$b set cog $newcog
		}
	}
	# update display
	updateDisplay $w
}


#=================================================================================================


proc stage::actionMenu {w x y X Y} {
variable $w
upvar 0 $w data

	# pick a body
	set what [$data(w:view) pickjoint $x $y]
	if {$what != ""} {
		set body [lindex $what 0]
		# configure the menu
		$w.m entryconfigure 0 -state normal \
				-command "figEditor::new .f_$body $data(v:routineEditor) $body {} 340x340"
		$w.m entryconfigure 1 -command "viewTrack::new .t_$body $data(v:routineEditor) $body" \
				-state normal

		$w.m entryconfigure 3 -state normal \
				-command "library::position:dialog $data(w:view) $body {$data(v:bodies)}"
		$w.m entryconfigure 4 -state normal
		$w.m.lib entryconfigure 0 -command "library::pose:dialog add $data(w:view) $body $w.m.lib"
		$w.m.lib entryconfigure 1 -command "library::pose:dialog add $data(w:view) $body $w.m.lib"
		$w.m.lib entryconfigure 2 -command "library::pose:dialog add $data(w:view) $body $w.m.lib"
		$w.m.lib entryconfigure 3 -command "library::pose:dialog add $data(w:view) $body $w.m.lib"
		$w.m.lib entryconfigure 4 -command "library::pose:dialog add $data(w:view) $body $w.m.lib"

		$w.m entryconfigure 6 -state normal -command "stage::restorePosition $w $body"
	} else {
		$w.m entryconfigure 0 -state disabled
		$w.m entryconfigure 1 -state disabled
		$w.m entryconfigure 3 -state disabled
		$w.m entryconfigure 4 -state disabled
		$w.m entryconfigure 6 -state disabled
	}

	tk_popup $w.m $X $Y
}

#-------------------------------------------------------------------------------------------------

proc stage::updateDisplay {w} {
variable $w
upvar 0 $w data

	pos:adjust $w cog:X 0
	pos:adjust $w cog:Y 0
	pos:adjust $w cog:Z 0
	pos:adjust $w cog:rX 0
	pos:adjust $w cog:rY 0
	pos:adjust $w cog:rZ 0

	foreach b $data(v:bodies) {
		set data(v:restore:$b) [$b get cog]
	}
	#resync the ghost
	ghost:sync $w
	# show main comment if title
	set routine [routine::getRoutine $data(v:routineEditor)]
	set comment [$routine note text [$routine get time] -1]
	set comment [join [split $comment "\n"] ", "]
	$data(w:comment) configure -text $comment
}

proc stage::restorePosition {w body} {
variable $w
upvar 0 $w data

	$body set cog $data(v:restore:$body)
}

#-------------------------------------------------------------------------------------------------

proc stage::body:adjust {w entry} {
variable $w
upvar 0 $w data


	# set selection in list
	set hlist [$data(w:bodies) subwidget hlist]
	$hlist selection clear
	$hlist selection set $entry
	$hlist anchor set $entry

	# refresh window
	set body [$hlist info data $entry]
	set data(v:body) $body
	updateDisplay $w
}

proc stage::pos:adjust {w var incr} {
variable $w
upvar 0 $w data


	if {$incr != 0} {
#puts "[$data(v:body) get $var] -- [expr [$data(v:body) get $var]+$incr]  :  [expr ([$data(v:body) get $var]+$incr)/double($incr)] -- [expr round(([$data(v:body) get $var]+$incr)/double($incr))*$incr]"
		set val [expr round(([$data(v:body) get $var]+$incr)/double($incr))*$incr]
	} else {
		set val [$data(v:body) get $var]
	}
	$data(v:body) set $var $val
	set data(v:$var) [format "%.2f" $val]

	if {$var == "cog:rY"} {
		set angle [expr 3.141592653/180*[$data(v:body) get cog:rY]]
		$data(w:orient) coords $data(orient:line) \
				[expr 25+50*sin($angle)] [expr 25-50*cos($angle)] 25 25
	}

	if {$incr} {
		set data(v:pending) [after 200 "stage::pos:adjust $w $var $incr"]
	}
}

proc stage::validateEntry {w var} {
variable $w
upvar 0 $w data

	set val $data(v:$var)
	if {[scan $val "%g%s" {} {}] != 1} {
		set data(v:$var) 0
		set val 0
	}

	$data(v:body) set $var $val
	set data(v:$var) [format "%.2f" $val]
}


#=================================================================================================

proc stage::initView {w} {
global status
variable $w
upvar 0 $w data

	set data(mode:old) 3d
	set data(mode) 3d
	replaceBindtags $data(w:view) "OpenGL" "View3D"

	#					   az  el  tw  zoom  xt   yt
	set data(var:3d)	 {-35  22   0   6.6	  0  -.7}
	set data(var:front)  {  0   0   0	  1	  0   -1}
    set data(var:back)   {180   0   0	  1   0   -1}
    set data(var:left)   { 90   0   0	  1   0   -1}
    set data(var:right)  {-90   0   0	  1   0   -1}
    set data(var:top)    {  0  90   0	  1   0    0}
    set data(var:bottom) {  0 -90   0	  1   0    0}

	set data(std:3d)	 $data(var:3d)
	set data(std:front)	 $data(var:front)
	set data(std:back)	 $data(var:back)
	set data(std:left)	 $data(var:left)
	set data(std:right)	 $data(var:right)
	set data(std:top)	 $data(var:top)
	set data(std:bottom) $data(var:bottom)

	$data(w:view) set view $data(var:3d)


	helpCreate $data(w:view) stage::${w}(st:help) stage::help

    menu $w.m -tearoff 0 -font popupmenu -bd 1 -activeborderwidth 1
	  $w.m add command -label "Edit pose ..."
	  $w.m add command -label "Edit track ..."
	  $w.m add separator
	  $w.m add command -label "Add position to library ..."
	  $w.m add cascade -label "Add pose to library" -menu $w.m.lib
	  menu $w.m.lib -tearoff 0 -font popupmenu -bd 1 -activeborderwidth 1
		$w.m.lib add command -label "Arm"
		$w.m.lib add command -label "Body"
		$w.m.lib add command -label "Foot"
		$w.m.lib add command -label "Leg"
		$w.m.lib add command -label "Pose"
	  $w.m add separator
	  $w.m add command -label "Restore position"
	  $w.m add separator
      $w.m add radio -label "3d" -command "stage::view $w 3d" \
	      -variable stage::${w}(mode) -value 3d
      $w.m add radio -label "Top" -command "stage::view $w top" \
	      -variable stage::${w}(mode) -value top
      $w.m add radio -label "Bottom" -command "stage::view $w bottom" \
	      -variable stage::${w}(mode) -value bottom
      $w.m add radio -label "Front" -command "stage::view $w front" \
	      -variable stage::${w}(mode) -value front
      $w.m add radio -label "Back" -command "stage::view $w back" \
	      -variable stage::${w}(mode) -value back
      $w.m add radio -label "Left" -command "stage::view $w left" \
	      -variable stage::${w}(mode) -value left
      $w.m add radio -label "Right" -command "stage::view $w right" \
	      -variable stage::${w}(mode) -value right
      $w.m add separator
	  set ${w}(floor) 1
	  set ${w}(axis) 1
	  set ${w}(forcewire) 0
	  $w.m add check -label "Floor" -variable stage::${w}(floor) \
		      -command "$data(w:view) set floor \[set stage::${w}(floor)\]"
	  $w.m add check -label "Axis" -variable stage::${w}(axis) \
		      -command "$data(w:view) set axis \[set stage::${w}(axis)\]"
	  $w.m add check -label "Force wireframe" -variable stage::${w}(wire) \
		      -command "$data(w:view) set forcewire \[set stage::${w}(wire)\]"

    bind $data(w:view) <ButtonPress-3> "stage::actionMenu $w %x %y %X %Y"

# 	bind $data(w:view) <ButtonPress-2> "stage::cog:setup $w %x %y"
# 	bind $data(w:view) <Button2-Motion> "stage::cog:motion $w %x %y"
# 	bind $data(w:view) <Shift-ButtonPress-2> "stage::rotate:setup $w %x %y"
# 	bind $data(w:view) <Shift-Button2-Motion> "stage::rotate:motion $w %x %y"
	bind $data(w:view) <ButtonPress-1> "if {\[stage::cog:setup $w %x %y\]} {break}"
	bind $data(w:view) <Button1-Motion> "if {\[stage::cog:motion $w %x %y\]} {break}"
	bind $data(w:view) <Shift-ButtonPress-1> "if {\[stage::rotate:setup $w %x %y\]} {break}"
	bind $data(w:view) <Shift-Button1-Motion> "if {\[stage::rotate:motion $w %x %y\]} {break}"
}

proc stage::orient:init {w wdata} {
variable $wdata
upvar 0 $wdata data


	set data(orient:line) [$w create line 25 1 25 25 -fill red]

	$w create rectangle  1  1  8  8 -fill lightgray -outline black
	$w create rectangle 21  1 28  8 -fill blue -outline black
	$w create rectangle 41  1 48  8 -fill lightgray -outline black
	$w create rectangle  1 21  8 28 -fill lightgray -outline black
	$w create rectangle 41 21 48 28 -fill lightgray -outline black
	$w create rectangle  1 41  8 48 -fill lightgray -outline black
	$w create rectangle 21 41 28 48 -fill lightgray -outline black
	$w create rectangle 41 41 48 48 -fill lightgray -outline black
}


### Translate the cog of body inside the plane XZ 
proc stage::cog:setup {w x y} {
variable $w
upvar 0 $w data

	set data(t:ok) 0
    set what [$data(w:view) pickjoint $x $y]
    if {$what != ""} {
		set body [lindex $what 0]
		if {[lsearch -exact $data(v:bodies) $body] == -1} {
			# we have selected a ghost : do nothing
			set data(t:ok) 0
			return 1
		}
		body:select $w $body

	    set data(t:X) $x
	    set data(t:Y) $y
	    set data(t:az) [$data(w:view) get azimut]
	    set data(t:zoom) [expr [$data(w:view) get zoom]/10]
	    set data(t:cog:X) [$data(v:body) get cog:X]
	    set data(t:cog:Z) [$data(v:body) get cog:Z]
		set data(t:ok) 1
		return 1
	} else {
		return 0
	}
}

proc stage::cog:motion {w x y} {
variable $w
upvar 0 $w data

	if {$data(t:ok)} {
		set az [expr 3.141592654*$data(t:az)/180]
		set tX [expr -($y-$data(t:Y))*sin($az)+($x-$data(t:X))*cos($az)]
		set tZ [expr ($y-$data(t:Y))*cos($az)+($x-$data(t:X))*sin($az)]
		set tX [expr $tX * $data(t:zoom) +$data(t:cog:X)]
		set tZ [expr $tZ * $data(t:zoom) +$data(t:cog:Z)]
		if {$data(mode) != "left" && $data(mode) != "right"} {
			$data(v:body) set cog:X $tX
		}
		if {$data(mode) != "front" && $data(mode) != "back"} {
			$data(v:body) set cog:Z $tZ
		}
		pos:adjust $w cog:X 0
		pos:adjust $w cog:Z 0
	}
	return $data(t:ok)
}


### Rotation of the cog round Y
proc stage::rotate:setup {w x y} {
variable $w
upvar 0 $w data

	set data(t:ok) 0
	set what [$data(w:view) pickjoint $x $y]
	if {$what != ""} {
		set body [lindex $what 0]
		body:select $w $body

		set data(t:x) $x
		set data(t:y) $y
		set data(t:zoom) [expr [$data(w:view) get zoom]/10]
		set data(t:az) [$data(w:view) get azimut]
		set data(t:ok) 1
		set data(t:rY) [$body get cog:rY]
	}
	return $data(t:ok)
}

proc stage::rotate:motion {w x y} {
variable $w
upvar 0 $w data

	if {$data(t:ok)} {
		set az [expr 3.141592654*$data(t:az)/180]
		set rX [expr ($y-$data(t:y))*cos($az)-(-$x+$data(t:x))*sin($az)]
		set rZ [expr -($y-$data(t:y))*sin($az)-(-$x+$data(t:x))*cos($az)]
		set rX [expr $rX * exp(sqrt($data(t:zoom))/10)]
		set rZ [expr $rZ * exp(sqrt($data(t:zoom))/10)]

		if {[catch {set angle [expr atan($rX/$rZ)]}]} {
			# if atan undefined : -pi/2 or pi/2
			if {$rX<0} {set angle -1.5707963} else {set angle 1.5707963}
		}

		# adjust atan from [-pi/2:pi/2] to [-pi/2:3pi/2]
		if {$rZ>0} {set angle [expr $angle + 3.141592654]}

		set angle [expr 180/3.141592654*$angle]
		if {$angle > 180} {
			set angle [expr $angle-360]
		}

		$data(v:body) set cog:rY [expr $data(t:rY)+$angle]
		pos:adjust $w cog:rY 0
	}
	return $data(t:ok)
}

#=================================================================================================

# array set stage::help {
# 	3d:normal "<1> Rotate view    <2> Move body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"
# 	proj:normal "<1> Translate view    <2> Move body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

# 	shift	"<1> Zoom view    <2> Rotate body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

# 	control	"<1> Translate view    <2> Move body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

# 	3d:alt	"<1> Translate center    <2> Move body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for ghosts"
# 	proj:alt "<1> Translate view    <2> Move body    <3> Action menu    <Key-1..9> Select body    <Arrow> Change time for ghosts"

# 	off		""}
array set stage::help {
	3d:normal "<L> Rotate view    <L-body> Move body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"
	proj:normal "<L> Translate view    <L-body> Move body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

	shift	"<L> Zoom view    <L-body> Rotate body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

	control	"<L> Translate view    <L-body> Move body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for characters"

	3d:alt	"<L> Translate center    <L-body> Move body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for ghosts"
	proj:alt "<L> Translate view    <L-body> Move body    <R> Action menu    <Key-1..9> Select body    <Arrow> Change time for ghosts"

	off		""}

set stage::help(normal) $stage::help(3d:normal)
set stage::help(alt) $stage::help(3d:alt)
